ARENALIVE_DATABASE = {};
ARENALIVE_DATABASE = ArenaLive_Defaults;

function ArenaLive_OnLoad(self)

	self:RegisterEvent("ADDON_LOADED");

end

--[[ ArenaLive_Database_AddAddOn
	Function to add an ArenaLive based AddOn's SavedVariables into the Database table ]]--
function ArenaLive_Database_UpdateAddOn (addonName, savedVariables)

	ARENALIVE_DATABASE[addonName] = savedVariables;

end

function ArenaLive_Database_UpdateSavedVariables (addonName, savedVariables)

	if ( addonName ) then
		savedVariables = ARENALIVE_DATABASE[addonName]
	else
		-- If no addOn Name is given, then we need to update our core saved variables
		savedVariables["options"]["debug"]  = ARENALIVE_DATABASE["options"]["debug"];
		savedVariables["options"]["overlayPriorities"] = ARENALIVE_DATABASE["options"]["overlayPriorities"];
		savedVariables["options"]["showCooldownText"] = ARENALIVE_DATABASE["options"]["showCooldownText"];
		savedVariables["options"]["castHistoryIconDuration"] = ARENALIVE_DATABASE["options"]["castHistoryIconDuration"];
	end

end

function ArenaLive_SystemMessage (msg, isDebug, addonDebug)

	if ( isDebug == true and addonDebug == false ) then
		return;
	elseif ( isDebug == true and addonDebug == true ) then
	
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000ArenaLive Debug:|r "..tostring(msg));
	
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000ArenaLive:|r "..tostring(msg));
	end
	
end



function ArenaLive_OnEvent(self, event, ...)
	
	local arg1 = ...
	
	if ( event == "ADDON_LOADED" and arg1 == "ArenaLiveCore" ) then
	
		-- If there are SavedVariables, we set up our Database. If not, we set the Defaults as SavedVariables.
		if (not ArenaLive_SavedVariables ) then
			ArenaLive_SavedVariables = ArenaLive_Defaults;
		else
			ARENALIVE_DATABASE = ArenaLive_SavedVariables;
		end
	end
end