-- HEALTHPREDICTIONBAR
function ArenaLiveHealPredictionBar_Initialise (unitFrame, healPredictionBar, healthBar)

	local healthBarWidth, healthBarHeight = healthBar:GetSize();
	healPredictionBar:SetSize(healthBarWidth, healthBarHeight);
	
	if ( healthBar:GetReverseFill() ) then
		healPredictionBar:SetPoint("TOPRIGHT", healthBar:GetStatusBarTexture(), "TOPLEFT");
	else
		healPredictionBar:SetPoint("TOPLEFT", healthBar:GetStatusBarTexture(), "TOPRIGHT");
	end
	
	ArenaLiveHealPredictionBar_UpdateMax(unitFrame);
	ArenaLiveHealPredictionBar_Update(unitFrame);
end



function ArenaLiveHealPredictionBar_UpdateMax (unitFrame)

	if ( not unitFrame.healPredictionBar ) then
		return;
	end
	
	-- Because we have dynamic unitframes, they sometimes don't have a unitID at startup, so we need to check for it.
	if ( not unitFrame.unit ) then
		unitFrame.healPredictionBar:SetMinMaxValues(0, 1);
	else
		local maxHealth = UnitHealthMax(unitFrame.unit);
		unitFrame.healPredictionBar:SetMinMaxValues(0, maxHealth);
	end

end



function ArenaLiveHealPredictionBar_UpdateSize (unitFrame)

	if ( not unitFrame.healPredictionBar ) then
		return;
	end
	
	local healthBarWidth, healthBarHeight = unitFrame.healthBar:GetSize();
	unitFrame.healPredictionBar:SetSize(healthBarWidth, healthBarHeight);

end



local MAX_INCOMING_HEAL_OVERFLOW = 1.0;
function ArenaLiveHealPredictionBar_Update (unitFrame)

	if ( not unitFrame.healPredictionBar ) then
		return;
	end

	if ( not ARENALIVE_DATABASE[unitFrame.addonName]["options"]["showHealPrediction"] or not unitFrame.unit ) then
		unitFrame.healPredictionBar:SetValue(0);
		return;
	end

	local predictedHeal = UnitGetIncomingHeals(unitFrame.unit) or 0;
	
	--Make sure we don't go too far out of the frame.
	local health = unitFrame.healthBar:GetValue();
	local _, maxHealth = unitFrame.healPredictionBar:GetMinMaxValues();
	
	--See how far we're going over.
	if ( health + predictedHeal > maxHealth * MAX_INCOMING_HEAL_OVERFLOW ) then
		predictedHeal = maxHealth * MAX_INCOMING_HEAL_OVERFLOW - health;
	end
	
	unitFrame.healPredictionBar:SetValue(predictedHeal);
end