ArenaLiveUnitFrames_Defaults =
{
	["options"] =
	{
		["version"] = "1.0",
		["debug"] = true,
		["showHealPrediction"] = true,
		["onlyShowCastableBuffs"] = false,
		["onlyShowDispellableDebuffs"] = false,
		["showAllEnemyDebuffs"] = true,
		["filterBuffsTournamentStyle"] = false,
	},
	["frameTypes"] =
	{
		["playerFrame"] =
		{
			["portraitType"] = "3D",
			["healthBarTextString"] = "%CURR_SHORT% / %MAX_SHORT% (%PERCENT_SHORT%%)",
			["powerBarTextString"] = "%CURR% / %MAX%",
			["healthBarColourMode"] = "none",
			["nameColourMode"] = "none",
			["icon1Type"] = "class",
			["icon2Type"] = "specialisation",
			["isLocked"] = true,
			
			["castBar"] = {
				["isShown"] = true,
				["position"] = "ABOVE";
			},
			["castHistory"] = {
				["isShown"] = true,
				["showTargetIndicator"] = true,
				["shownIcons"] = 6,
				["iconSize"] = 18,
			},
			["auraFrame"] = {
				["isShown"] = true,
				["position"] = "BELOW";
				["growUpwards"] = false,
				["iconSize"] = 17,		
				["largeIconSize"] = 21,
				["iconSpacing"] = 3,
				["maxShownBuffs"] = 32,
				["maxShownDebuffs"] = 16,
				["rtlAuras"] = false,
				
			},
		},
		["targetFrame"] =
		{
			["portraitType"] = "3D",
			["healthBarTextString"] = "%CURR_SHORT% / %MAX_SHORT% (%PERCENT_SHORT%%)",
			["powerBarTextString"] = "%CURR% / %MAX%",
			["healthBarColourMode"] = "none",
			["nameColourMode"] = "none",
			["icon1Type"] = "class",
			["icon2Type"] = "reaction",
			["isLocked"] = true,
			
			["castBar"] = {
				["isShown"] = true,
				["position"] = "ABOVE";
			},
			["castHistory"] = {
				["isShown"] = true,
				["showTargetIndicator"] = true,
				["shownIcons"] = 6,
				["iconSize"] = 18,
			},
			["auraFrame"] = {
				["isShown"] = true,
				["position"] = "BELOW";
				["growUpwards"] = false,
				["iconSize"] = 17,		
				["largeIconSize"] = 21,
				["iconSpacing"] = 3,
				["maxShownBuffs"] = 32,
				["maxShownDebuffs"] = 16,
				["rtlAuras"] = true,
				
			},
		},
	},
};
ArenaLive_Database_UpdateAddOn("ArenaLiveUnitFrames", ArenaLiveUnitFrames_Defaults);

function ArenaLiveUnitFrames_OnLoad(self)
	
	self:RegisterEvent("ADDON_LOADED");
end

function  ArenaLiveUnitFrames_OnEvent(self, event, ...)
	
	if ( event == "ADDON_LOADED" and select(1,...) == "ArenaLiveUnitFrames" ) then
		ArenaLiveUnitFrames_AddOnLoaded()
	end
end

function ArenaLiveUnitFrames_AddOnLoaded()
	
	if (not ArenaLiveUnitFrames_SavedVariables ) then
		ArenaLiveUnitFrames_SavedVariables = ArenaLiveUnitFrames_Defaults;
	end
	
	PlayerFrame:SetScript("OnEvent", nil);
	PlayerFrame:Hide();
	TargetFrame:SetScript("OnEvent", nil);
	TargetFrame:Hide();
	ComboFrame:SetScript("OnEvent", nil);
	ComboFrame:Hide();
	ArenaLive_Database_UpdateAddOn ("ArenaLiveUnitFrames", ArenaLiveUnitFrames_SavedVariables);
end
