local DropDownOptions = 
	{
		["Portrait"] = {
			[1] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanel3DPortrait"],
				["value"] = "3D",
			},
			[2] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelClassPortrait"],
				["value"] = "class",
			},
		},
		["IconType"] = {
			[1] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelClass"],
				["value"] = "class",		
			},
			[2] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelRace"],
				["value"] = "race",	
			},
			[3] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelTrinket"],
				["value"] = "trinket",		
			},
			[4] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelRacial"],
				["value"] = "racial",			
			},
			[5] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelSpec"],
				["value"] = "specialisation",			
			},
			[6] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelDoI"],
				["value"] = "interruptOrDispel",			
			},
			[7] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelReact"],
				["value"] = "reaction",		
			},
		},
		["HealthBarColourMode"] = {
			[1] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelNone"],
				["value"] = "none",	
				
			},
			[2] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelClassColour"],
				["value"] = "byClass",	
				
			},
			[3] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelReact"],
				["value"] = "byReaction",	
				
			},
		},
		["NameColourMode"] = {
			[1] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelNone"],
				["value"] = "none",	
				
			},
			[2] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelClassColour"],
				["value"] = "byClass",	
				
			},
			[3] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelReact"],
				["value"] = "byReaction",	
				
			},
		},
		["Position"] = {
			[1] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelAbove"],
				["value"] = "ABOVE",	
				
			},
			[2] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelBelow"],
				["value"] = "BELOW",	
			},
			[3] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelLeft"],
				["value"] = "LEFT",	
				
			},
			[3] = {
				["text"] = ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelRight"],
				["value"] = "RIGHT",	
			},
		},
		
	}

local UnitFrameTypes =
	{
		[1] = "options";
		[2] = "playerFrame";
		[3] = "targetFrame";
	}
local UnitFrameTabNames = {
	[1] = "General",
	[2] = "PlayerFrame",
	[3] = "TargetFrame",
};
local UnitFramePanels = {
	[1] = "ALUF_OptionsUnitFramePanelGeneral",
	[2] = "ALUF_OptionsUnitFramePanelPlayerFrame",
	[3] = "ALUF_OptionsUnitFramePanelTargetFrame",
};
function ALUF_Options_OnLoad (self)

	-- Create a Panel in Blizzard AddOn Panel
	local version = ARENALIVE_DATABASE["options"]["version"];
	self.name = "ArenaLive UnitFrames";
	self.okay = ALUF_Options_Okay;
	self.cancel = ALUF_Options_Cancel;
	self.parent = "ArenaLive";
	InterfaceOptions_AddCategory(self);
	self:RegisterEvent("ADDON_LOADED");
	
	
end

function ALUF_Options_OnEvent (self, event, ...)
	arg1 = ...;
	
	if ( event == "ADDON_LOADED" and arg1 == "ArenaLiveUnitFrames" ) then
		-- General Options:
		ALUF_Options_CheckButtonInitialise(ALUF_OptionsUnitFramePanelGeneralDebug);
		ALUF_Options_CheckButtonInitialise(ALUF_OptionsUnitFramePanelGeneralHealPrediction);
		ALUF_Options_CheckButtonInitialise(ALUF_OptionsUnitFramePanelGeneralOnlyShowCastableBuffs);
		ALUF_Options_CheckButtonInitialise(ALUF_OptionsUnitFramePanelGeneralOnlyShowDispellableDebuffs);
		ALUF_Options_CheckButtonInitialise(ALUF_OptionsUnitFramePanelGeneralShowAllEnemyDebuffs);
		
		-- Checkbuttons
		ALUF_Options_CheckButtonInitialise(ALUF_OptionsUnitFramePanelPlayerFrameShowCastBar);
		ALUF_Options_CheckButtonInitialise(ALUF_OptionsUnitFramePanelPlayerFrameShowCastHistory);
		ALUF_Options_CheckButtonInitialise(ALUF_OptionsUnitFramePanelPlayerFrameShowAuras);
		ALUF_Options_CheckButtonInitialise(ALUF_OptionsUnitFramePanelPlayerFrameIsLocked);
		
		ALUF_Options_CheckButtonInitialise(ALUF_OptionsUnitFramePanelTargetFrameShowCastBar);
		ALUF_Options_CheckButtonInitialise(ALUF_OptionsUnitFramePanelTargetFrameShowCastHistory);
		ALUF_Options_CheckButtonInitialise(ALUF_OptionsUnitFramePanelTargetFrameShowAuras);
		ALUF_Options_CheckButtonInitialise(ALUF_OptionsUnitFramePanelTargetFrameIsLocked);
		
		-- EditBoxes:
		ArenaLive_Options_EditBoxInitialise(ALUF_OptionsUnitFramePanelPlayerFrameHealthBarText);
		ArenaLive_Options_EditBoxInitialise(ALUF_OptionsUnitFramePanelPlayerFramePowerBarText);
		
		ArenaLive_Options_EditBoxInitialise(ALUF_OptionsUnitFramePanelTargetFrameHealthBarText);
		ArenaLive_Options_EditBoxInitialise(ALUF_OptionsUnitFramePanelTargetFramePowerBarText);		
		
		-- DropDowns:
		UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFramePortraitType, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["portraitType"], false);
		UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameIcon1, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["icon1Type"], false);
		UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameIcon2, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["icon2Type"], false);
		UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameHealthBarColour, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["healthBarColourMode"], false);
		UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameNameColour, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["nameColourMode"], false);
		UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameCastBarPosition, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["castBar"]["position"], false);
		UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameAuraPosition, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["auraFrame"]["position"], false);

		UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelTargetFramePortraitType, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["portraitType"], false);
		UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameIcon1, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["icon1Type"], false);
		UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameIcon2, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["icon2Type"], false);
		UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameHealthBarColour, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["healthBarColourMode"], false);
		UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameNameColour, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["nameColourMode"], false);
		UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameCastBarPosition, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["castBar"]["position"], false);
		UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameAuraPosition, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["auraFrame"]["position"], false);
		
		-- Sliders
		ALUF_Options_SliderInitialise(ALUF_OptionsUnitFramePanelPlayerFrameCastHistoryShownIcons);
		
		ALUF_Options_SliderInitialise(ALUF_OptionsUnitFramePanelTargetFrameCastHistoryShownIcons);
	end

end

function ALUF_Options_UnitFramePanelOnLoad (self)

	-- Set number of Panel Tabs. This is to use the PanelTemplate by Blizzard.
	PanelTemplates_SetNumTabs(self, 3);
	self.selectedTab = 1;
	PanelTemplates_UpdateTabs(self);
	ALUF_Options_UnitFramePanelTabOnClick(ALUF_OptionsUnitFramePanelTab1);
end



function ALUF_Options_UnitFramePanelTabOnLoad (self)
	local prefix = self:GetName();
	local id =  self:GetID();
	local text = _G[prefix.."Text"];
	text:SetText(UnitFrameTabNames[id])

end



function ALUF_Options_UnitFramePanelTabOnClick (self)

	PlaySound("igCharacterInfoTab");
	PanelTemplates_Tab_OnClick(self, ALUF_OptionsUnitFramePanel);
	
	--[[ The name of the local "unitFrame" may be a bit confusing. Basically it's not the unitframe itself, but the
		name of the option frame for the unitframe type. ]]--
	for i = 1, ALUF_OptionsUnitFramePanel.numTabs do
		local prefix = "ALUF_OptionsUnitFramePanelTab"..i;
		local unitFrameName = UnitFramePanels[i];
		local unitFrame = _G[unitFrameName];
		
		if ( i == ALUF_OptionsUnitFramePanel.selectedTab ) then
		
			if ( unitFrame ) then
				unitFrame:Show();
				
				if ( i == 1 ) then
					_G[prefix.."TabSpacer"]:Show();
				else
					_G[prefix.."TabSpacer1"]:Show();
					_G[prefix.."TabSpacer2"]:Show();
				end
			end
		
		else
			if ( unitFrame ) then
				unitFrame:Hide();
				if ( i == 1 ) then
					_G[prefix.."TabSpacer"]:Hide();
				else
					_G[prefix.."TabSpacer1"]:Hide();
					_G[prefix.."TabSpacer2"]:Hide();
				end
			end
		end
	end
	
end



function ALUF_Options_Okay (self)

	-- General Options:
	ArenaLiveUnitFrames_SavedVariables["options"]["debug"] = ALUF_OptionsUnitFramePanelGeneralDebug:GetChecked();
	ArenaLiveUnitFrames_SavedVariables["options"]["showHealPrediction"] = ALUF_OptionsUnitFramePanelGeneralHealPrediction:GetChecked() ;
	ArenaLiveUnitFrames_SavedVariables["options"]["onlyShowCastableBuffs"] = ALUF_OptionsUnitFramePanelGeneralOnlyShowCastableBuffs:GetChecked() ;
	ArenaLiveUnitFrames_SavedVariables["options"]["onlyShowDispellableDebuffs"] = ALUF_OptionsUnitFramePanelGeneralOnlyShowDispellableDebuffs:GetChecked() ;
	ArenaLiveUnitFrames_SavedVariables["options"]["showAllEnemyDebuffs"] = ALUF_OptionsUnitFramePanelGeneralShowAllEnemyDebuffs:GetChecked() ;
	
	-- CHECKBUTTONS:
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["playerFrame"]["castBar"]["isShown"] = ALUF_OptionsUnitFramePanelPlayerFrameShowCastBar:GetChecked();
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["playerFrame"]["castHistory"]["isShown"] = ALUF_OptionsUnitFramePanelPlayerFrameShowCastHistory:GetChecked();
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["playerFrame"]["auraFrame"]["isShown"] = ALUF_OptionsUnitFramePanelPlayerFrameShowAuras:GetChecked();
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["playerFrame"]["isLocked"] = ALUF_OptionsUnitFramePanelPlayerFrameIsLocked:GetChecked();

	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["targetFrame"]["castBar"]["isShown"] = ALUF_OptionsUnitFramePanelTargetFrameShowCastBar:GetChecked();
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["targetFrame"]["castHistory"]["isShown"] = ALUF_OptionsUnitFramePanelTargetFrameShowCastHistory:GetChecked();
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["targetFrame"]["auraFrame"]["isShown"] = ALUF_OptionsUnitFramePanelTargetFrameShowAuras:GetChecked();
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["targetFrame"]["isLocked"] = ALUF_OptionsUnitFramePanelTargetFrameIsLocked:GetChecked();
	
	-- EDITBOXES:
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["playerFrame"]["healthBarTextString"] = ALUF_OptionsUnitFramePanelPlayerFrameHealthBarText:GetText();
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["playerFrame"]["powerBarTextString"] = ALUF_OptionsUnitFramePanelPlayerFramePowerBarText:GetText();
	
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["targetFrame"]["healthBarTextString"] = ALUF_OptionsUnitFramePanelTargetFrameHealthBarText:GetText();
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["targetFrame"]["powerBarTextString"] = ALUF_OptionsUnitFramePanelTargetFramePowerBarText:GetText();
	
	-- DROPDOWNS:
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["playerFrame"]["portraitType"] = UIDropDownMenu_GetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFramePortraitType);
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["playerFrame"]["icon1Type"] = UIDropDownMenu_GetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameIcon1);
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["playerFrame"]["icon2Type"] = UIDropDownMenu_GetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameIcon2);
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["playerFrame"]["healthBarColourMode"] = UIDropDownMenu_GetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameHealthBarColour);
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["playerFrame"]["nameColourMode"] = UIDropDownMenu_GetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameNameColour);
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["playerFrame"]["castBar"]["position"] = UIDropDownMenu_GetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameCastBarPosition);
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["playerFrame"]["auraFrame"]["position"] = UIDropDownMenu_GetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameAuraPosition);

	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["targetFrame"]["portraitType"] = UIDropDownMenu_GetSelectedValue(ALUF_OptionsUnitFramePanelTargetFramePortraitType);
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["targetFrame"]["icon1Type"] = UIDropDownMenu_GetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameIcon1);
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["targetFrame"]["icon2Type"] = UIDropDownMenu_GetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameIcon2);
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["targetFrame"]["healthBarColourMode"] = UIDropDownMenu_GetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameHealthBarColour);
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["targetFrame"]["nameColourMode"] = UIDropDownMenu_GetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameNameColour);
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["targetFrame"]["castBar"]["position"] = UIDropDownMenu_GetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameCastBarPosition);
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["targetFrame"]["auraFrame"]["position"] = UIDropDownMenu_GetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameAuraPosition);
	
	-- SLIDERS:
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["playerFrame"]["castHistory"]["shownIcons"] = ALUF_OptionsUnitFramePanelPlayerFrameCastHistoryShownIcons:GetValue();
	
	ArenaLiveUnitFrames_SavedVariables["frameTypes"]["targetFrame"]["castHistory"]["shownIcons"] = ALUF_OptionsUnitFramePanelTargetFrameCastHistoryShownIcons:GetValue();
	
	-- Now Update the ARENALIVE_DATABASE to the new values
	ArenaLive_Database_UpdateAddOn("ArenaLiveUnitFrames", ArenaLiveUnitFrames_SavedVariables);
	
	-- Update the frames so they get the new values.
	ALUF_PlayerFrame_Update(ALUF_PlayerFrame);
	ALUF_PlayerFrame_AdjustAttachments(ALUF_PlayerFrame);
	
	ALUF_TargetFrame_Update(ALUF_TargetFrame);
	ALUF_TargetFrame_AdjustAttachments(ALUF_TargetFrame);
end



function ALUF_Options_Cancel()
	
	-- General Options:
	ALUF_OptionsUnitFramePanelGeneralDebug:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["options"]["debug"]);
	ALUF_OptionsUnitFramePanelGeneralHealPrediction:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["options"]["showHealPrediction"]);
	ALUF_OptionsUnitFramePanelGeneralOnlyShowCastableBuffs:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["options"]["onlyShowCastableBuffs"]);
	ALUF_OptionsUnitFramePanelGeneralOnlyShowDispellableDebuffs:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["options"]["onlyShowDispellableDebuffs"]);
	ALUF_OptionsUnitFramePanelGeneralShowAllEnemyDebuffs:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["options"]["showAllEnemyDebuffs"]);
	
	-- CHECKBUTTONS
	ALUF_OptionsUnitFramePanelPlayerFrameShowCastBar:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["castBar"]["isShown"]);
	ALUF_OptionsUnitFramePanelPlayerFrameShowCastHistory:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["castHistory"]["isShown"]);
	ALUF_OptionsUnitFramePanelPlayerFrameShowAuras:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["auraFrame"]["isShown"]);
	ALUF_OptionsUnitFramePanelPlayerFrameIsLocked:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["isLocked"]);

	ALUF_OptionsUnitFramePanelTargetFrameShowCastBar:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["castBar"]["isShown"]);
	ALUF_OptionsUnitFramePanelTargetFrameShowCastHistory:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["castHistory"]["isShown"]);
	ALUF_OptionsUnitFramePanelTargetFrameShowAuras:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["auraFrame"]["isShown"]);
	ALUF_OptionsUnitFramePanelTargetFrameIsLocked:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["isLocked"]);
	
	-- EDITBOXES:
	ALUF_OptionsUnitFramePanelPlayerFrameHealthBarText:SetText(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["healthBarTextString"]);
	ALUF_OptionsUnitFramePanelPlayerFramePowerBarText:SetText(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["powerBarTextString"]);

	ALUF_OptionsUnitFramePanelTargetFrameHealthBarText:SetText(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["healthBarTextString"]);
	ALUF_OptionsUnitFramePanelTargetFramePowerBarText:SetText(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["powerBarTextString"]);
	
	-- DROPDOWNS
	UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFramePortraitType, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["portraitType"], false);
	UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameIcon1, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["icon1Type"], false);
	UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameIcon2, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["icon2Type"], false);
	UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameHealthBarColour, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["healthBarColourMode"], false);
	UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameNameColour, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["nameColourMode"], false);
	UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameCastBarPosition, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["castBar"]["position"], false);
	UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelPlayerFrameAuraPosition, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["auraFrame"]["position"], false);

	UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelTargetFramePortraitType, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["portraitType"], false);
	UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameIcon1, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["icon1Type"], false);
	UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameIcon2, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["icon2Type"], false);
	UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameHealthBarColour, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["healthBarColourMode"], false);
	UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameNameColour, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["nameColourMode"], false);
	UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameCastBarPosition, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["castBar"]["position"], false);
	UIDropDownMenu_SetSelectedValue(ALUF_OptionsUnitFramePanelTargetFrameAuraPosition, ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["auraFrame"]["position"], false);
	
	-- Sliders
	ALUF_OptionsUnitFramePanelPlayerFrameCastHistoryShownIcons:SetValue(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["castHistory"]["shownIcons"]);
	
	ALUF_OptionsUnitFramePanelTargetFrameCastHistoryShownIcons:SetValue(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["targetFrame"]["castHistory"]["shownIcons"]);
	
end



-- CHECKBUTTONS
function ALUF_Options_CheckButtonInitialise (self)
	
	local buttonName = self:GetName();
	local textString = _G[buttonName.."Text"];

	textString:SetText(ARENALIVE_LOCALISATION[self.titleLocalisation]);
	
	if ( not self.frameType ) then
		self:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["options"][self.affectedVariable]);
	elseif ( self.frameType and not self.nestedLevel ) then
		self:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"][self.frameType][self.affectedVariable]);
	elseif ( self.frameType and self.nestedLevel ) then
		self:SetChecked(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"][self.frameType][self.nestedLevel][self.affectedVariable]);
	end
	
	
end



-- EDITBOXES
function ArenaLive_Options_EditBoxInitialise(self)

	local editBoxName = self:GetName();
	local textString = _G[editBoxName.."Text"];
	
	textString:SetText(ARENALIVE_LOCALISATION[self.titleLocalisation]);

	if ( not self.frameType ) then
		self:SetText(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["options"][self.affectedVariable]);
	elseif ( self.frameType and not self.nestedLevel ) then
		self:SetText(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"][self.frameType][self.affectedVariable]);
	elseif ( self.frameType and self.nestedLevel ) then
		self:SetText(ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"][self.frameType][self.nestedLevel][self.affectedVariable]);
	end
	
	-- We need to reset the EditBox's cursor position, so that the text is shown correctly.
	self:SetCursorPosition(0);
	
end



-- DROPDOWNS
function ALUF_Options_DropDownOnLoad(self)

	local title = _G[self:GetName().."Title"];
	
	-- Set the Title of the DropDown:
	if ( self.dropDownType == "Portrait" ) then
		title:SetText(ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelPortraitTitle"]);
	elseif ( self.dropDownType == "HealthBarColourMode" ) then
		title:SetText(ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelHealthBarColourTitle"]);
	elseif ( self.dropDownType == "IconType" ) then
		local id = self:GetID();
		title:SetText(ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelIcon"..id.."Title"]);
	elseif ( self.dropDownType == "NameColourMode" ) then
		title:SetText(ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelNameColourTitle"]);
	elseif ( self.dropDownType == "Position" ) then
		title:SetText(ARENALIVE_LOCALISATION["ALUF_OptionsUnitFramePanelPositionTitle"]);
	end
	
	for key, value in ipairs(DropDownOptions[self.dropDownType]) do
		-- Some frames do not have all possible entries, so we filter it with the ingoreEntries table. The table is defined in the OnLoad Script for every DropDown in the options.xml
		if ( not self.ignoreEntries or ( self.ignoreEntries and not self.ignoreEntries[key] ) ) then	
			local info = UIDropDownMenu_CreateInfo();
			info.text = value.text;
			info.value = value.value;
			info.func = ALUF_Options_DropDownSetValue;
			info.arg1 = self; -- dropDownFrame in ALUF_Options_DropDownSetValue
			UIDropDownMenu_AddButton(info);	
		end
	end
end



function ALUF_Options_DropDownSetValue(self, dropDownFrame)
	UIDropDownMenu_SetSelectedValue(dropDownFrame, self.value, false);

end


-- SLIDER
function  ALUF_Options_SliderInitialise(self)

	local prefix = self:GetName();
	local title = _G[prefix.."Title"];
	local currText = _G[prefix.."Curr"];
	local minText = _G[prefix.."Low"];
	local maxText = _G[prefix.."High"];
	local currValue;
	local minValue, maxValue = self:GetMinMaxValues();
	
	if ( not self.frameType ) then
		currValue = ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["options"][self.affectedVariable];
	elseif ( self.frameType and not self.nestedLevel ) then
		currValue = ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"][self.frameType][self.affectedVariable];
	elseif ( self.frameType and self.nestedLevel ) then
		currValue = ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"][self.frameType][self.nestedLevel][self.affectedVariable];
	end
	
	self:SetValue(currValue);
	title:SetText(ARENALIVE_LOCALISATION[self.titleLocalisation]);
	minText:SetText(minValue);
	currText:SetText(currValue);
	maxText:SetText(maxValue);
end



function ALUF_Options_SliderOnValueChanged(self)
	
	local prefix = self:GetName();
	local currText = _G[prefix.."Curr"];
	local currValue = self:GetValue();
	currText:SetText(currValue);
end